#!/bin/bash

set -x
# 1. this assumes that you have installed the FlowTracker tool
export PATH=$PATH:~/llvm37/build/Release+Asserts/bin

PROGRAM=ctaes
XML=ctaes

LLVM37_PATH=~/llvm37/build/Release+Asserts/lib

# 2. this assumes Mac OS X (change dylib to so if using Linux)
ALIAS_SETS=${LLVM37_PATH}/AliasSets.dylib
DEP_GRAPH=${LLVM37_PATH}/DepGraph.dylib
BSSA2=${LLVM37_PATH}/bSSA2.dylib

clang -emit-llvm -c -g ${PROGRAM}.c -o ${PROGRAM}.bc || exit 1
opt -instnamer -mem2reg ${PROGRAM}.bc > ${PROGRAM}.rbc || exit 1
opt -basicaa -load ${ALIAS_SETS} -load ${DEP_GRAPH} -load ${BSSA2} -bssa2 -xmlfile ${XML}.in.xml ${PROGRAM}.rbc

set +x
